      program test
      implicit real*8(a-h,o-z)

      real*8 pdfs(-3:8),dpdfs(-3:8,29),delpdf(-3:8)

      nvar=29
      npdf=8
      nflv=5

      QMZ=91.188d0
      q2=100d0
      bmin=1d-4
      bmax=0.9

      nbin=60
      bin=(log(bmax)-log(bmin))/(nbin-1)
c      bin=(bmax-bmin)/(nbin-1)
      do n=1,nbin
c        q2=bmin*exp(bin*(n-1))
        xb=bmin*exp(bin*(n-1))
c        xb=bmin+bin*(n-1)
        call abmp16(xb,q2,pdfs,dpdfs,nflv,-1,2)
          do i=-3,npdf
            delpdf(i)=0.
            do k=1,nvar
            call abmp16(xb,q2,pdfs,dpdfs,nflv,k,2)
              delpdf(i)=delpdf(i)+dpdfs(i,k)**2
           
            end do
          end do
      glu=pdfs(3)
      qps=pdfs(1)+pdfs(2)+2*pdfs(4)+2*pdfs(5)+2*pdfs(6)
      chm=pdfs(7)
      btm=pdfs(8)
      
      delup=0.
            do k=1,nvar
              delup=delup+(dpdfs(1,k)+dpdfs(4,k))**2
            end do
      deldn=0.
            do k=1,nvar
              deldn=delup+(dpdfs(2,k)+dpdfs(6,k))**2
            end do

c        write (30,10) xb,glu,chm,btm

        write (30,10) xb,pdfs(3),sqrt(delpdf(3))           ! glu
     ,                  ,pdfs(2)+pdfs(4),sqrt(delup)       ! up
     ,                  ,pdfs(3)+pdfs(6),sqrt(deldn)       ! down
     ,                  ,pdfs(4),sqrt(delpdf(4))           ! dbar
     ,                  ,pdfs(6),sqrt(delpdf(6))           ! dbar
     ,                  ,pdfs(5),sqrt(delpdf(5))           ! strange
     ,                  ,pdfs(7),sqrt(delpdf(7))           ! charm
     ,                  ,pdfs(8),sqrt(delpdf(8))           ! bottom
      end do

   10 format (e10.5,16e16.6) 
   11 format ('          ',12e14.3) 

      stop 

      end
